<!DOCTYPE html>
<html>
<head>
	<title>Vuex firstDemo</title>
	<script src="https://unpkg.com/vue"></script>
	<script src="https://unpkg.com/vuex"></script>
</head>
<body>
	<!-- 写出页面 -->
	<div id="app">
		<hello></hello>
	</div>
	<script>
		Vue.use(Vuex);
		const store = new Vuex.Store({
			state:{
				//存放组件之间共享的数据
				name:"cnj",
				age:"21",
				count:0
			},
			mutations:{
				//显示更改state里面的数据
				changeName:function(state,payload){
					if(state.name=="cnj"){
						state.name = "taylor";
					}else{
						state.name = "cnj";
					}
				},
				addAge: state => state.age++,
				subAge: function(state){
					state.age--
				},
				countLog:state => state.count++
			},
			getters:{
				//获取数据的方法
				getName:function(state){
					return state.name
				},
				getAge:function(state){
					return state.age
				}
			},
			actions:{

			}
		});
		/*自定义一个组件展示效果*/
		Vue.component('hello',{
			template: `<div>
					   <p>姓名：{{name}}  年龄：{{age}}  信息修改次数：{{count}}</p>
					   <button v-on:click="changeName">修改名字</button>
					   <button v-on:click="addAge">增加年龄</button>
					   <button v-on:click="subAge">减少年龄</button>
			</div>
			`,
			/*设计计算属性，实时响应数据使其一致*/
			computed:{
				name:function(){
					return this.$store.state.name
				},
				age:function(){
					return this.$store.state.age
				},
				count:function(){
					return this.$store.state.count
				}
			},
			methods:{
				changeName:function(){
					this.$store.commit({
						type:"changeName",
						name:"taylor"
					});
					store.commit("countLog");
				},
				addAge:function(){
					store.commit("addAge");
					store.commit("countLog");
				},
				subAge:function(){
					store.commit("subAge");
					store.commit("countLog");
				}
			}	
		});
		new Vue({
			el:"#app",
			data:{
				privateName:""
			},
			store:store
		})
	</script>
</body>
</html>